!********************************************************************************
!	3-Dimensional Monte Carlo Simulation for grain growth
!********************************************************************************
	Program main
	USE DFLIB
	integer (4) status,status1,result2,mouseevent, keystate,x,y
	integer (4) status2,status3,status4
	logical (4) result1,result3,result4,result5,result6,result7
	logical (4) retlog
	external run
	TYPE (QWINFO) qwi
	result6=MAKEDIRQQ('c:\MC')
	result3= MAKEDIRQQ('c:\MC\orien')
	result4= MAKEDIRQQ('c:\MC\size')
	result5= MAKEDIRQQ('c:\MC\topol')
	result7= MAKEDIRQQ('c:\MC\temp')
	qwi.type=qwin$max
	status = SETWSIZEQQ(0,qwi)
	status = SETWSIZEQQ(QWIN$FRAMEWINDOW,qwi)
	call run
	result1 = INSERTMENUQQ(1,1,$MENUENABLED,'&Run'C, run)
	status1 = ABOUTBOXQQ ('Monte Carlo Simulation of Grain Growth\n
	1Develeloped by S. Sista, Z. Yang and T. DebRoy\n
	1The Pennsylvania State University\n
	12000 S. Sista, Z. Yang and T. DebRoy'c)


33	mouseevent = MOUSE$LBUTTONDOWN
	result2 = waitonmouseevent(mouseevent,keystate,x,y)
	GOTO 33
	end
!*********************************************
	subroutine run
	USE DFLOGM
	USE DFLIB  
	INCLUDE 'resource.fd'  
	include 'comblock.f'
	logical retlog,rundef
	integer retint, value,result10,result11
	character*60 const(13),filn(10),filenames,str, numpl(10),filor(10)
	real compdat
	TYPE (DIALOG) dlg
!*****************************************************************************
!	GUI preparation
!*****************************************************************************
	retlog=dlginit(dialog3, dlg)
	retint = DlgModal( dlg )
	CALL DlgUninit( dlg )
	if(retint.eq.1041) goto 999

1112	retlog=dlginit(dialog1, dlg)
	retlog = DlgSet( dlg, edit_Xgrid, '100')
	retlog = DlgSet( dlg, edit_Ygrid, '100')
	retlog = DlgSet( dlg, edit_Zgrid, '100')
	retlog = DlgSet( dlg, edit_maxor, '48')
	retlog = DlgSet( dlg, edit_imcmax, '100')
	retlog = DlgSet( dlg, edit_nneig, '26')
	retlog = DlgSet( dlg, edit_temp, '923')
	retlog = DlgSet( dlg, edit_lambda, '40e-6')
	retlog = DlgSet( dlg, edit_deliter, '10')
	retlog = DlgSet( dlg, ID_interfac, '0.8')
	retlog = DlgSet( dlg, ID_coord, '3')
	retlog = DlgSet( dlg, ID_numat, '2.0e19')
	retlog = DlgSet( dlg, ID_missor, '0.0')

	retint = DlgModal( dlg )

	retlog = DlgGet( dlg, edit_Xgrid, const(1))
	retlog = DlgGet( dlg, edit_Ygrid, const(2))
	retlog = DlgGet( dlg, edit_Zgrid, const(3))
	retlog = DlgGet( dlg, edit_maxor, const(4))
	retlog = DlgGet( dlg, edit_imcmax, const(5))
	retlog = DlgGet( dlg, edit_nneig, const(6))
	retlog = DlgGet( dlg, edit_temp, const(7))
	retlog = DlgGet( dlg, edit_lambda, const(8))
	retlog = DlgGet( dlg, edit_deliter, const(9))
	retlog = DlgGet( dlg, ID_interfac, const(10))
	retlog = DlgGet( dlg, ID_coord, const(11))
	retlog = DlgGet( dlg, ID_numat, const(12))
	retlog = DlgGet( dlg, ID_missor, const(13))

	read(const(1),*) compdat(1)
	read(const(2),*) compdat(2)
	read(const(3),*) compdat(3)
	read(const(4),*) compdat(4)
	read(const(5),*) compdat(5)
	read(const(6),*) compdat(6)
	read(const(7),*) compdat(7)
	read(const(8),*) compdat(8)
	read(const(9),*) compdat(9)
	read(const(10),*) compdat(10)
	read(const(11),*) compdat(11)
	read(const(12),*) compdat(12)
	read(const(13),*) compdat(13)
	if(compdat(1).gt.100.or.compdat(2).gt.100.or.compdat(3).gt.100)
	1then
	 result10 = MESSAGEBOXQQ('You have exceeded the array limit of 
	1 100x100x100.'C,'OOPS!'C,MB$OK)
	 goto 1112
	 endif 
	 result11 = MESSAGEBOXQQ('Please donot attempt to change the 
	1 directory structure! Only the filenames can be changed'C,
     1'Warning!'C,MB$OK)

	CALL DlgUninit( dlg )
	if(retint.eq.1030) goto 999
	if(retint.eq.1002) goto 1112
	if (retint.eq.1084) then
	rundef=.true.
	call grainiso(rundef)
	goto 1115
	endif

1111	retlog=dlginit(dialog2, dlg)
	retlog = DlgSet( dlg, file_gij, "c:\MC\size\Mgsize.dat")
	retlog = DlgSet( dlg, file_index, "c:\MC\topol\Gridindex.dat")
	retlog = DlgSet( dlg, file_perimeter, "c:\MC\topol\
	1Perimeter.dat")
	retlog = DlgSet( dlg, file_numofsid, "c:\MC\topol\Nosides.dat")
	retlog = DlgSet( dlg, file_angle, "c:\MC\topol\Anglesides.dat")
	retlog = DlgSet( dlg, file_gsd, "c:\MC\size\Gsdist.dat")

	retint = DlgModal( dlg )

	retlog = DlgGetchar( dlg, file_gij, filn(1))
	retlog = DlgGetchar( dlg, file_index, filn(2))
	retlog = DlgGetchar( dlg, file_perimeter, filn(3))
	retlog = DlgGetchar( dlg, file_numofsid, filn(4))
	retlog = DlgGetchar( dlg, file_angle, filn(5))
	retlog = DlgGetchar( dlg, file_gsd, filn(6))

	read(filn(2),*) filenames(4)
	read(filn(3),*) filenames(5)
	read(filn(4),*) filenames(6)
	read(filn(5),*) filenames(7)
	read(filn(1),*) filenames(9)
	read(filn(6),*) filenames(16)

	CALL DlgUninit( dlg )
	if(retint.eq.1014) goto 1112
	if(retint.eq.1028) goto 999
	if(retint.eq.1029) goto 1111
	if(retint.eq.1034) then
	rundef = .true.
	call grainiso(rundef)
	goto 1115
	endif
!	New Dialog
1021	retlog=dlginit(dialog5, dlg)
!***********************************************************************
!	set default values for six plane edit boxes
	retlog=DlgSet(dlg,IDC_EDIT2,'33')
	retlog=DlgSet(dlg,IDC_EDIT3,'33')
	retlog=DlgSet(dlg,IDC_EDIT4,'33')
	retlog=DlgSet(dlg,IDC_EDIT5,'66')
	retlog=DlgSet(dlg,IDC_EDIT6,'66')
	retlog=DlgSet(dlg,IDC_EDIT7,'66')
!
	retlog=DlgSet(dlg,IDC_EDIT8,"c:\MC\orien\OrienX33.dat")
	retlog=DlgSet(dlg,IDC_EDIT15,"c:\MC\orien\OrienY33.dat")
	retlog=DlgSet(dlg,IDC_EDIT16,"c:\MC\orien\OrienZ33.dat")
	retlog=DlgSet(dlg,IDC_EDIT17,"c:\MC\orien\OrienX66.dat")
	retlog=DlgSet(dlg,IDC_EDIT18,"c:\MC\orien\OrienY66.dat")
	retlog=DlgSet(dlg,IDC_EDIT19,"c:\MC\orien\OrienZ66.dat")

	retint = DlgModal( dlg )
!	Get values for six planes
	retlog = DlgGet(dlg,IDC_EDIT2,numpl(2))
	retlog = DlgGet(dlg,IDC_EDIT3,numpl(3))
	retlog = DlgGet(dlg,IDC_EDIT4,numpl(4))
	retlog = DlgGet(dlg,IDC_EDIT5,numpl(5))
	retlog = DlgGet(dlg,IDC_EDIT6,numpl(6))
	retlog = DlgGet(dlg,IDC_EDIT7,numpl(7))

	read(numpl(2),*)number(2)
	read(numpl(3),*)number(3)
	read(numpl(4),*)number(4)
	read(numpl(5),*)number(5)
	read(numpl(6),*)number(6)
	read(numpl(7),*)number(7)

!
	retlog = DlgGet(dlg,IDC_EDIT8,filor(2))
	retlog = DlgGet(dlg,IDC_EDIT15,filor(3))
	retlog = DlgGet(dlg,IDC_EDIT16,filor(4))
	retlog = DlgGet(dlg,IDC_EDIT17,filor(5))
	retlog = DlgGet(dlg,IDC_EDIT18,filor(6))
	retlog = DlgGet(dlg,IDC_EDIT19,filor(7))

	read(filor(2),*)filenames(10)
	read(filor(3),*)filenames(11)
	read(filor(4),*)filenames(12)
	read(filor(5),*)filenames(13)
	read(filor(6),*)filenames(14)
	read(filor(7),*)filenames(15)


	CALL DlgUninit( dlg )
	if(retint.eq.1078) goto 999
	if(retint.eq.1002) goto 1021
	if(retint.eq.1079) goto 1111

	call grainiso(rundef)

!	New Dialog
1115	retlog=dlginit(dialog4, dlg)
	retint = DlgModal( dlg )
	CALL DlgUninit( dlg )
	if(retint.eq.1046) then
	call clearscreen($gclearscreen)
	goto 1112
	endif
999	end subroutine

!************************************************

!*********************************************************************	
	subroutine grainiso(rundef)
	use dflib
	include 'comblock.f'
!------Dimension and define type of the variables used----------------------

      dimension in(neig),jn(neig),kn(neig),itr(neig),number1(7)
!*****in,jn,kn are the neighbouring i,j,k indices and itr is transition probability for 
!*****the neighbours.
      integer date_time(8)
	real compdat, compdat1(nm2)
      character*60 filenames, str,filenames1(nz),str1
	logical rundef
!-----These few lines are used to calculate the time required for the program to run
	 call date_and_time (values = date_time)
        nhou=date_time(5)
        nmin=date_time(6)
        nsec=date_time(7)
        ntot=nhou*3600+(nmin*60)+(nsec)

!----------------------------------------------------------------------------------
!----------------------------------------------------------------------------------
	write(6,*)'           THE 3D MONTE CARLO           '
	write(6,*)'               SIMULATION               '
	write(6,*)'                PROGRAM                 '
	write(6,*)'                                     '
       write(6,*)'Developed by S. Sista, Z. Yang and T. DebRoy'
       write(6,*)'       The Pennsylvania State University'   
!-------------data required for the names variables in user interface--------------
!----------------Default values for Computational Variables-----------
      if(rundef) then
	data compdat1/100.,100.,100.,48.,200.,26.,923.,40.e-6,10.,0.8,
	113.,2.0e19,0.0/
	compdat=compdat1
	data filenames1/'c:\MC\orien\OrienX0.dat',
	1'null','null','c:\MC\topol\gridindex.dat',
	1'c:\MC\topol\perimeter.dat','c:\MC\topol\Nosides.dat',
	1'c:\MC\topol\Anglesides.dat','null','c:\MC\size\mgsize.dat',
     1'c:\MC\orien\OrienX33.dat','c:\MC\orien\OrienY33.dat',
	1'c:\MC\orien\OrienZ33.dat','c:\MC\orien\OrienX66.dat',
	1'c:\MC\orien\OrienY66.dat','c:\MC\orien\OrienZ66.dat','c:\MC\topol
     1\Gsdist.dat'/
	filenames=filenames1
	str1='X'
	str=str1
	data number1/33,33,33,33,66,66,66/
	number=number1
	endif
!-----Input data----------------------------------------------------
!*******************************************************************
!     imax,jmax,kmax: Size of lattice
!     iqmax    : Maximum orientation number (The default value is 32)
!     imcmax   : Total Monte Carlo step
!     nneig    : No. of Nearest Neighbors
!*******************************************************************
2	continue
127   imax=compdat(1)
	jmax=compdat(2)
	kmax=compdat(3)
	iqmax=compdat(4)
	imcmax=compdat(5)
	nneig=compdat(6)
	cangle=compdat(13) !Critical misorientation parameter
	angcon=(2.0*180.0)/float(iqmax) !Constatnt in misorientation angle 
!					calculation
	mcstepold = 1
!*******Start of calculations***************************************
        write(*,*)'The time now is:',nhou,':',nmin,':',nsec
	  write(*,*)
	  write(*,*)'Depending on the problem size and processor speed,' 
        write(*,*)'each iteraton may take a few minutes.'

!------Constants and initial values of variables-----------
      num=imax*jmax*kmax
      itry=0
	nn=0
	agamma = compdat(10)
	aZ=compdat(11) !Coordination Number
	aN=compdat(12) !
      ak = 1.38e-23 ! Boltzmann constant
      aj = agamma/(aZ*aN) ! Energy Scale
	T=compdat(7) !temeprature at which the simulation is being done.
      idmax=2147483647 !Maximum value of a long integer
      ajkt = aj/(ak*T)
!-------Assign a random orientation to each site-------------
	call random_seed()
	 do 10 i=1,imax
       do 10 j=1,jmax
       do 10 k=1,kmax
       call random_number(ran)
       val=float(iqmax)*ran
       iq(i,j,k)=int(1.+val)
10     continue
!--------Beginning of MCS iteration------------------------------
	write(*,*)
 	write(*,*)'       Mcstep', '    Cumulative successful'
	write(*,*)'                    reorientations'
      do 200 mcstep=1,imcmax
      write(*,*)mcstep,itry
!---------Randomly select site------------------------------
 	call random_seed()
         do 190 ij=1, num
!-------Selection of random number generators---------------
          Call random_number(xx)
          call random_number(yy)
          call random_number(zz)
          call random_number(rr)
 	   ix=int(1.+float(imax)*xx)
         iy = int(1.+float(jmax)*yy)
         iz = int(1.+float(kmax)*zz)
!---------find neighbors of the selected site----------
       nne=0
	do 25 i=-1,1
       do 25 j=-1,1
        do 25 k=-1,1
       if((i.eq.0).and.(j.eq.0).and.(k.eq.0)) goto 25
       nne=nne+1
       in(nne)=ix+i
	jn(nne)=iy+j
       kn(nne)=iz+k
       in(nne) = amax0(1,in(nne))
       in(nne) = amin0(in(nne),imax)
       jn(nne) = amax0(1,jn(nne))
       jn(nne) = amin0(jn(nne),jmax)
       kn(nne) = amax0(1,kn(nne))
       kn(nne) = amin0(kn(nne),kmax)
25    continue
      
!----count number of neighbors having the same OR (before updating)--    
       ior=iq(ix,iy,iz)
       nor=0
       E0=0.
       v1=1.0
       do 30 j=1, nneig
       ior1=iq(in(j),jn(j),kn(j))
       if(ior1.gt.iqmax+3) goto 30
       if(ior1.ne.ior) then
        angle0=angcon*abs(float(ior-ior1))
        if(angle0.gt.180.) angle0=360.-angle0
        if(cangle.lt.0.0001) goto 281
        if (angle0.lt.cangle) then
        ratio=angle0/cangle
        v1=ratio*(1.0-alog(ratio))
        endif
281	E0=E0+v1
	endif
30     continue
!	angle0: misorientation angle
!	v1    : local anisotropy potential related to misorientation
!	E0    : Interfacial energy before switching orientation
!----count number of neighbors having the same OR (after updating)-- 
!      New OR selected from one of the neighbors
112     call random_number(ran1)
       j=int(1.+float(nneig)*ran1*0.999999) !0.999999 is used so as make j.le.26
       ior2=iq(in(j),jn(j),kn(j))
	if(ior2.gt.iqmax+3) goto 112
       E1=0
       v1=1.0
       nor1=0
       do 50 k=1,nneig
       ior3=iq(in(k),jn(k),kn(k))
       if(ior3.gt.iqmax+3) goto 50
        if(ior2.ne.ior3) then
        angle0=angcon*abs(float(ior3-ior2))
        if(angle0.gt.180.) angle0=360.-angle0
        if(cangle.lt.0.0001) goto 481
        if (angle0.lt.cangle) then
        ratio=angle0/cangle
        v1=ratio*(1.0-alog(ratio))
        endif
481      E1=E1+v1
        endif
50     continue
!----Judge whether switching or not----------------------------
        DE=E1-E0
        if(DE.le.0.) then
        iq(ix,iy,iz)=ior2
        itry=itry+1
        else
!----Transition Probability---------------------------------
      do 5 i=1, nneig
      xit=float(i)
      trb=float(idmax)*exp(-xit*ajkt)
      itr(i)=int(trb)
5     continue
        idelta=int(DE)
        call random_number(ran2)
        idummy=int(1.+float(idmax)*ran2)
        if (idummy.le.itr(idelta)) then
          iq(ix,iy,iz)=ior2
          itry=itry+1
        end if
	end if
  190 continue
	call grnsiz(mcstep)

!------output results--------------------------------------
!	output results every 'n' steps
	if(mod(mcstep,int(compdat(9))).eq.0) then
	nn=nn+1
!***********************************************************
!	for six planes
	open(unit=61,file=filenames(12))
	write(61,*)'VARIABLES="I","J","K","IQ"'
        write(61,*)'Zone I=',Jmax,',J=',Imax,',K=',1,',F=POINT' 
	k=number(4)
	Do 3002 i=1,imax
	do 3002 j=1,jmax 
3002  Write(61,*)i,j,k,iq(i,j,k)
 
	open(unit=63,file=filenames(11))
	write(63,*)'VARIABLES="I","J","K","IQ"'
      write(63,*)'Zone I=',Kmax,',J=',imax,',K=',1,',F=POINT' 
	j= number(3)
	Do 3003 i=1,imax
	do 3003 k=1,kmax
3003  write(63,*)i,j,k,iq(i,j,k)

	open(unit=64,file=filenames(10))
	write(64,*)'VARIABLES="I","J","K","IQ"'
      write(64,*)'Zone I=',kmax,',J=',jmax,',K=',1,',F=POINT' 
	i= number(2)
	Do 3004 j=1,jmax
	do 3004 k=1,kmax
3004  write(64,*)i,j,k,iq(i,j,k)

	open(unit=65,file=filenames(15))
	write(65,*)'VARIABLES="I","J","K","IQ"'
        write(65,*)'Zone I=',Jmax,',J=',Imax,',K=',1,',F=POINT' 
	k=number(7)
	Do 3005 i=1,imax
	do 3005 j=1,jmax 
3005  Write(65,*)i,j,k,iq(i,j,k)
 
	open(unit=66,file=filenames(14))
	write(66,*)'VARIABLES="I","J","K","IQ"'
      write(66,*)'Zone I=',Kmax,',J=',imax,',K=',1,',F=POINT' 
	j= number(6)
	Do 3006 i=1,imax
	do 3006 k=1,kmax
3006  write(66,*)i,j,k,iq(i,j,k)

	open(unit=67,file=filenames(13))
	write(67,*)'VARIABLES="I","J","K","IQ"'
      write(67,*)'Zone I=',kmax,',J=',jmax,',K=',1,',F=POINT' 
	i= number(5)
	Do 3007 j=1,jmax
	do 3007 k=1,kmax
3007  write(67,*)i,j,k,iq(i,j,k)
*******************************************************************
!	Write for the movie
*******************************************************************

	open(unit=610,file="c:\mc\orien\orienZ1.dat")
	if (nn.eq.1) then
	write(610,*)'VARIABLES="I","J","K","IQ"'
	endif
        write(610,*)'Zone I=',Jmax,',J=',Imax,',K=',1,',F=POINT' 
	k=1
	Do 30020 i=1,imax
	do 30020 j=1,jmax 
30020  Write(610,*)i,j,k,iq(i,j,k)
 
	open(unit=630,file="c:\mc\orien\orienY1.dat")
	if (nn.eq.1) then
	write(630,*)'VARIABLES="I","J","K","IQ"'
	endif
      write(630,*)'Zone I=',Kmax,',J=',imax,',K=',1,',F=POINT' 
	j= 1
	Do 30030 i=1,imax
	do 30030 k=1,kmax
30030  write(630,*)i,j,k,iq(i,j,k)

	open(unit=640,file="c:\mc\orien\orienX1.dat")
	if (nn.eq.1) then
	write(640,*)'VARIABLES="I","J","K","IQ"'
	endif
      write(640,*)'Zone I=',kmax,',J=',jmax,',K=',1,',F=POINT' 
	i= 1
	Do 30040 j=1,jmax
	do 30040 k=1,kmax
30040  write(640,*)i,j,k,iq(i,j,k)

*******************************************************************


	close(61)
	close(63)
	close(64)
	close(65)
	close(66)
	close(67)

	call averages(mcstep,mcstepold)
	endif !If (mod..)



200	continue

!************************************************************
4	format(2x,79('-'))
19	format(2x,a5,2x,a60,a2)
29	format(2x,a5,2x,a20,a2)
31	format(2x,a5,1x,i2,1x,a9,1x,a29,1x,a1,a8,a1)
39	format(2x,a30,1x,i2,a2)
49	format(2x,a5,1x,i2,1x,a34,/2x/79('-'))
59	format(2x,a5,1x,i2,1x,a9,1x,a50,a1,1pe10.3,a1)
69	format(2x,a5,1x,i1,1x,a38)
79	format(2x,79('-'),/15x,a40)
89	format(a30)
99	format(2x,a5,1x,i1,1x,a15,a40)
	write(*,*)'Monte Caro Simulation Finished.'
	call date_and_time (values = date_time)
	nhou1 = date_time(5)
	nmin1= date_time(6)
	nsec1=date_time(7)
      write(*,*)'The time now is:',nhou1,':',nmin1,':',nsec1
	Ntot1=nhou1*3600+(nmin1*60)+(nsec1)
	ndiff=abs(ntot1-ntot)
	nsecs=mod(ndiff,60)
        nmins=(ndiff-nsecs)/60
        nminsnew=mod(nmins,60)
        nhours=(nmins-nminsnew)/60
        write(*,*)'The Time taken is :',nhours,':',nminsnew,':',nsecs
999 	  end

!--------Measure grain size gradient-------------------------
        subroutine grnsiz(mcstep)
        include 'comblock.f'
        real compdat
	character*60 filenames


        open(unit=402,file=filenames(9))

        n1=0
	n3=0
	aik=0.0
	aki=0.0
	aij=0.0
	aji=0.0
	ajk=0.0
	akj=0.0
!*****For the IK plane******************************************
        do 105 k=1,kmax,2
       n1=n1+1
        icounti1=1
        do 155 i=2,imax
        j=number(3)
        if (iq(i,j,k).ne.iq(i-1,j,k)) icounti1=icounti1+1
155      continue
         aik=aik+(float(imax)/float(icounti1))*compdat(8)*1.e6
105	continue
       do 106 i=1,imax,2
        n3=n3+1
        icounti2=1
        do 156 k=2,kmax
        j=number(3)
        if (iq(i,j,k).ne.iq(i,j,k-1)) icounti2=icounti2+1
156      continue
 
         aki=aki+(float(kmax)/float(icounti2))*compdat(8)*1.e6

106      continue
	   avgsizeik=((aik/n1)+(aki/n3))/2.

!**********For the IJ plane***************************************
        n2=0
	n4=0
        do 205 j=1,jmax,2
            n2=n2+1
            icountj1=1
        do 255 i=2,imax
        k=number(4)
        if (iq(i,j,k).ne.iq(i-1,j,k)) icountj1=icountj1+1
255      continue
        aij=aij+(float(imax)/float(icountj1))*compdat(8)*1.e6

205      continue

        do 206 i=1,imax,2
            n4=n4+1
            icountj2=1
        do 256 j=2,jmax
        k=number(4)
        if (iq(i,j,k).ne.iq(i,j-1,k)) icountj2=icountj2+1
256      continue
        aji=aji+(float(jmax)/float(icountj2))*compdat(8)*1.e6

206      continue
	   avgsizeij=((aij/n2)+(aji/n4))/2.
!**********For the JK plane***************************************
        n5=0
	n6=0
        do 305 j=1,jmax,2
            n5=n5+1
            icountk1=1
        do 355 k=2,kmax
        i=number(2)
        if (iq(i,j,k).ne.iq(i,j,k-1)) icountk1=icountk1+1
355      continue
        ajk=ajk+(float(kmax)/float(icountk1))*compdat(8)*1.e6

305      continue

        do 306 k=1,kmax,2
            n6=n6+1
            icountk2=1
        do 356 j=2,jmax
        i=number(2)
        if (iq(i,j,k).ne.iq(i,j-1,k)) icountk2=icountk2+1
356      continue
        akj=akj+(float(jmax)/float(icountk2))*compdat(8)*1.e6

306      continue
	   avgsizejk=((akj/n6)+(ajk/n5))/2.
!**************************************************************************
        n1=0
	n3=0
	aik=0.0
	aki=0.0
	aij=0.0
	aji=0.0
	ajk=0.0
	akj=0.0

!*****For the IK plane******************************************
        do 115 k=1,kmax,2
       n1=n1+1
        icounti1=1
        do 165 i=2,imax
        j=number(6)
        if (iq(i,j,k).ne.iq(i-1,j,k)) icounti1=icounti1+1
165      continue
         aik=aik+(float(imax)/float(icounti1))*compdat(8)*1.e6

115	continue
       do 116 i=1,imax,2
        n3=n3+1
        icounti2=1
        do 166 k=2,kmax
        j=number(6)
        if (iq(i,j,k).ne.iq(i,j,k-1)) icounti2=icounti2+1
166      continue
 
         aki=aki+(float(kmax)/float(icounti2))*compdat(8)*1.e6

116      continue
	   avgsizeik1=((aik/n1)+(aki/n3))/2.

!**********For the IJ plane***************************************
        n2=0
	n4=0
        do 215 j=1,jmax,2
            n2=n2+1
            icountj1=1
        do 265 i=2,imax
        k=number(7)
        if (iq(i,j,k).ne.iq(i-1,j,k)) icountj1=icountj1+1
265      continue
        aij=aij+(float(imax)/float(icountj1))*compdat(8)*1.e6
	if (mcstep.eq.40.or.mcstep.eq.200) then
	  write(1005,*)mcstep,j,aij,icountj1
	endif

215      continue

        do 216 i=1,imax,2
            n4=n4+1
            icountj2=1
        do 266 j=2,jmax
        k=number(7)
        if (iq(i,j,k).ne.iq(i,j-1,k)) icountj2=icountj2+1
266      continue
        aji=aji+(float(jmax)/float(icountj2))*compdat(8)*1.e6

216      continue
	   avgsizeij1=((aij/n2)+(aji/n4))/2.
!**********For the JK plane***************************************
        n5=0
	n6=0
        do 315 j=1,jmax,2
            n5=n5+1
            icountk1=1
        do 365 k=2,kmax
        i=number(5)
        if (iq(i,j,k).ne.iq(i,j,k-1)) icountk1=icountk1+1
365      continue
        ajk=ajk+(float(kmax)/float(icountk1))*compdat(8)*1.e6

315      continue

        do 316 k=1,kmax,2
            n6=n6+1
            icountk2=1
        do 366 j=2,jmax
        i=number(5)
        if (iq(i,j,k).ne.iq(i,j-1,k)) icountk2=icountk2+1
366      continue
        akj=akj+(float(jmax)/float(icountk2))*compdat(8)*1.e6
	if (mcstep.eq.40.or.mcstep.eq.200) then
	  write(1006,*)mcstep,k,akj,icountk2
	endif

316      continue
	   avgsizejk1=((akj/n6)+(ajk/n5))/2.
********************************************************************

		Average6 = (avgsizeij+avgsizejk+avgsizeik+avgsizeij1
     &+avgsizejk1+avgsizeik1)/6.
        write(402,*)"Average grain size (micro meter) after 
     &iteration #",mcstep,"=", Average6
********************************************************************
	return
         End subroutine
